---

- name: Create VM from template - with dhcp
  community.vmware.vmware_guest:
    validate_certs: "{{ vcenter_validate_certs }}"
    name: "{{ instance_name }}"
    template: "{{ vmware_template }}"
    datacenter: "{{ vmware_datacenter }}"
    datastore: "{{ vmware_datastore }}"
    folder: "{{ vmware_folder }}"
    state: poweredon
    convert: "{{ instance_parameters.vmware_instance_disktype | default('thin') }}"
    cluster: "{{ vmware_cluster }}"
    disk:
    - datastore: "{{ vmware_datastore }}"
      disk_mode: persistent
      size_gb: "{{ instance_parameters.vmware_instance_diskgb }}"
      controller_type: 'paravirtual'
      controller_number: 0
      unit_number: 0
    networks:
    - name: "{{ instance_parameters.vmware_network }}"
      start_connected: true
      type: "dhcp"
    hardware:
      memory_mb: "{{ instance_parameters.vmware_instance_memmb }}"
      num_cpus: "{{ instance_parameters.vmware_instance_cpus }}"
    customization:
      hostname: "{{ instance_name }}"
    wait_for_ip_address: true
  register: vmware_guest
  when: instance_parameters.vmware_network_type == 'dhcp'

- name: Create VM from template - with static ip
  community.vmware.vmware_guest:
    validate_certs: "{{ vcenter_validate_certs }}"
    datacenter: "{{ vmware_datacenter }}"
    folder: "{{ vmware_folder }}"
    name: "{{ instance_name }}"

    template: "{{ vmware_template }}"
    state: poweredon
    convert: "{{ instance_parameters.vmware_instance_disktype | default('thin') }}"
    cluster: "{{ vmware_cluster }}"
    disk:
    - datastore: "{{ vmware_datastore }}"
      disk_mode: persistent
      size_gb: "{{ instance_parameters.vmware_instance_diskgb }}"
      controller_type: 'paravirtual'
      controller_number: 0
      unit_number: 0
    networks:
    - name: "{{ instance_parameters.vmware_network }}"
      ip: '{{ instance_parameters.vmware_ip_address }}'
      netmask: '{{ instance_parameters.vmware_netmask }}'
      gateway: '{{ instance_parameters.vmware_gateway }}'
      dns_servers:
      - '{{ instance_parameters.vmware_dns_server1 }}'
      start_connected: true
      type: static
      device_type: "vmxnet3"
    hardware:
      memory_mb: "{{ instance_parameters.vmware_instance_memmb }}"
      num_cpus: "{{ instance_parameters.vmware_instance_cpus }}"
    customization:
      dns_servers:
      - '{{ instance_parameters.vmware_dns_server1 }}'
      domain : '{{ vmware_domain_name }}'
      hostname: "{{ instance_name }}"
    wait_for_ip_address: true
  register: vmware_guest
  when: instance_parameters.vmware_network_type == 'static'

- name: display what vm was created
  ansible.builtin.debug:
    var: vmware_guest

- name: display what ipv4 address was created
  ansible.builtin.debug:
    var: vmware_guest.instance.ipv4

- name: Add host to in memory inventory
  ansible.builtin.add_host:
    name: "{{ instance_name }}"
    ansible_host: "{{ vmware_guest.instance.ipv4 }}"
    ansible_user: "{{ vmware_ansible_user }}"
    groups:
      - "{{ instance_group | default('all_hosts') }}"
##  when: dns_update | bool

- name: test SSH connection
  ansible.builtin.wait_for_connection:
    timeout: 300
